;Chong Carl
;SPARC EQUATES.INC

.include "c:\users\cc88\8515def.inc" 

;Universal Truths
.dseg 
.equ	TRUE	=0FFh		;Yes
.equ	FALSE	=00h		;No

;Timer setup.
;No storage needed, this just calculates a value for the timer based on
;the desired sample rate and the clock frequency, with constants for the
;internal chip prescalers and dividers.

.equ	XTAL		=8000000;in Hz
.equ	T0_DIV1		=$01	;
.equ	T0_DIV8		=$02	;
.equ	T0_DIV64	=$03	;
.equ	T0_DIV256	=$04	;
.equ	T0_DIV1024	=$05	;
.equ	T0DIV		=(255-127)	;Make for even MS! 1% error

;Register definitions

.def	TEMP7		=R5	;Only used in the servo code
.def	ZERO		=R6	;Always Zero!
.def	LOOP		=R13	;Loop counter, local usage only.

.def	TEMP		=R16	
.def	TEMP2		=R17	
.def	TEMP3		=R18	
.def	TEMP4		=R19	
.def	TEMP5		=R20	
.def	TEMP6		=R21	
.def	TTEMP		=R23	
.def	TTEMP2		=R24	
.def	TTEMP3		=R25	

;Ram buffers
;Everything after this resides in specified locations in RAM.
.org 0x60	;The beginning of RAM (Since we are in a DSEG)

;**************************************************************;
;R/C Servo control bytes, load each byte with a value 0-255 corresponding to
;ccw - cw rotation position. 

SERVO_1:	.byte	1	;Servo width value
SERVO_2:	.byte	1	;Servo width value
SERVO_3:	.byte	1	;Servo width value
SERVO_4:	.byte	1	;Servo width value
SERVO_5:	.byte	1	;Servo width value
SERVO_6:	.byte	1	;Servo width value
SERVO_7:	.byte	1	;Servo width value
SERVO_8:	.byte	1	;Servo width value
Servo_Control:	.byte	1	;Servo active flags, always only one bit on, maybe none
Frame_Delay:	.byte	1	;Servo frame delay counter, decremented by T1OVF interrupt

;Derive Servo_Base from Xtal and the structure of the servo control routines such that 
;a SERVO_X value of 0 gives one end of rotation, and 255 gives the other.

.equ	T1Divisor = 1		;Fixed in the servo routine

;So, we have a T1CR rate of 8MHz, and we'd like to have something that
;will result in an appropriate minimum pulse if SERVO_X = 0

;This handles the different brands of servos, which require slightly different 
;pulse widths to achieve the same travel range
;Just enter the time for minimum position, and max position, in uS, and we'll take
;care of the rest.

.equ	Futaba_Min	= 1000	;Microseconds for minimum position
.equ	Futaba_Max	= 2000	;Microseconds for maximum position
.equ	Futaba_Range	= (Futaba_Max - Futaba_Min)

.equ	Fmin	=	(65535 - (Futaba_Min * 4))
.equ	Frange	=	(Futaba_Range * 4)

;Assign these as you populate your servos.
;This sets the min and max pulse widths, in uS for each servo. The servo position is 
;then given for any servo by (Brand_Range / 256) * Position_Byte)

.equ	Servo_1_Min	= Fmin
.equ	Servo_1_Range	= Frange

.equ	Servo_2_Min	= Fmin
.equ	Servo_2_Range	= Frange

.equ	Servo_3_Min	= Fmin
.equ	Servo_3_Range	= Frange

.equ	Servo_4_Min	= Fmin
.equ	Servo_4_Range	= Frange

.equ	FRAME_RATE 	= 1	;Milliseconds between servo pulse bursts dec'd by TO ISR