;Chong Carl
;SPARC INIT.ASM

INIT_Machine:

;Set Watchdog Inactive
	ldi	TEMP,$1F	;00011011	
	out	WDTCR,TEMP	
	ldi	TEMP,$17	;00010111
	out	WDTCR,TEMP	
	ldi	TEMP,0		
	mov	ZERO,TEMP	

;Set the stack pointer to 025F, stack grows down. 
        ldi	TEMP,0x5f	;
	out     SPL,TEMP        ;init Stack Pointer Low     
	ldi	temp,0x02	;
        out     SPL+1,TEMP      ;init Stack Pointer High

;This section allows inits which are apparently 
;caused by reset, to occur harmlessly.
	ldi	TEMP,$40	;
	out	GIMSK,TEMP	;Enable int 0,1
	ldi	TEMP,$02	;
	out	TIMSK,TEMP	;Enable all timer ints
	in	TEMP,SREG	;
	ori	TEMP,$80	;Global int enable
	out	SREG,TEMP	;
	nop
	nop
	nop	
	nop	
	nop
	nop
	nop	
	nop	
	nop

	in	TEMP,SREG	;
	andi	TEMP,$7F	;Turn off all ints
	out	SREG,TEMP	;

	ldi	TEMP,$00	;Disable all timer ints 
	out	TIMSK,TEMP	;

	ldi	TEMP,$00	;Disable all ints
	out	GIMSK,TEMP	;

	;At this point, SPARC is awake and clean
;*******************************************************************
;Set the I/O pins to their appropriate state.
	ldi	TEMP,$FF	;OOOOOOOO 
	out	DDRA,TEMP	;Set port A data direction
	ldi	TEMP,$00	;
	out	PORTD,TEMP	;Set all outputs initially low

	;LEDs are lit by outputting a low level
	ldi	TEMP,$FF	;OOOOOOOO
	out	DDRB,TEMP	;Set port B data direction
	ldi	TEMP,$00	;
	out	PORTD,TEMP	;Set all outputs initially low

	ldi	TEMP,$FF	;OOOOOOOO 
	out	DDRC,TEMP	;Set port C data direction
	ldi	TEMP,$00	;
	out	PORTD,TEMP	;Set all outputs initially low

	;Buttons pressed present a LOW to the AVR
	ldi	TEMP,$00	;IIIIIIII
	out	DDRD,TEMP	;Set port D data direction
	out	PORTD,TEMP	;De-Activate the pullups (supplied on board)
;*******************************************************************
;Set up the analog comparator to disabled
	ldi	TEMP,$90	
	out	ACSR,TEMP	
;*******************************************************************
;Set SPI inactive
	ldi	TEMP,$1B	
	out	SPCR,TEMP	
;*******************************************************************
;Set EEProm Inactive 
	ldi	TEMP,$00	
	out	EECR,TEMP	
;*******************************************************************
;Set up the MCU Control register (5-31)
	ldi	TEMP,$02	
	out	MCUCR,TEMP	
;*******************************************************************
;Set timer zero running
	ldi	TEMP,T0_DIV64	;This plus reloading T0 to 255-(T0DIV) gives us 1ms with an 8M rock
	out	TCCR0,TEMP	;Set the prescaler
	ldi	TEMP,T0DIV	;Preload timer since
	out 	TCNT0, TEMP	
;*******************************************************************
;Set timer one for servo use 
	ldi	TEMP,$00	;Disable PWM modes
	out	TCCR1A,TEMP	
	ldi	TEMP,$00	
	out	TCCR1B,TEMP	
;*******************************************************************
;Start the timer ints, I use the "dumb" timer for system ints, and
;leaving the "smart" timer for servo control
	ldi	TEMP,$02	;Enable timer 0 ints
	out	TIMSK,TEMP	;

	in	TEMP,TIMSK	;
	ori	TEMP,$80	;Turn on timer 1 overflow int
	out	TIMSK,TEMP	;for servo control
	
	in	TEMP,SREG	;
	ori	TEMP,$80	;Enable global ints 
	out	SREG,TEMP	;

;ALL DONE setting up SPARC!
;*******************************************************************
;Initial states for RC servo control using timer 2
	rcall	Init_Servo		;SERVO.ASM
;*******************************************************************
;Turn off the LEDs
	ldi	TEMP,$FF		;Turn off the lights
	out	PORTB,TEMP		;
;*******************************************************************
;Now that the machine is properly set up, we can go do something useful!
	rjmp	IDLE
;*******************************************************************
